#include <sys/errno.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>

#include <iostream>
#include <string>
using namespace std;

int main(void)
{
   const char *addr = "127.0.0.1";
   unsigned short port = 8804;
   struct sockaddr_in server_addr;
   int sock = socket(PF_INET, SOCK_STREAM, IPPROTO_TCP);
   if (sock == -1)
   {
      cerr << "Unable to create socket" << endl;
      return errno;
   }
   memset(&server_addr, 0, sizeof(server_addr));
   server_addr.sin_family = AF_INET;
   server_addr.sin_port = htons(port);
   server_addr.sin_addr.s_addr = inet_addr(addr);
   if (connect(sock, (struct sockaddr*) (&server_addr), sizeof(server_addr)) < 0)
   {
      cerr << "Unable to connect to server" << endl;
      close(sock);
      return errno;
   }
   string str;
   while (1)
   {
      getline(cin, str);
      if (send(sock, str.c_str(), str.size() + 1, 0) != (ssize_t)(str.size() + 1))
      {
         cerr << "Unable to send message" << endl;
         return errno;
      }
      if ((str[0] == 'i') || (str[0] == 's'))
      {
         char c;
         ssize_t count = 0;
         string resp = "";
         do
         {
            if ((count = recv(sock, &c, sizeof(c), 0)) == 1)
            {
               //cout << "Received " << c << endl;
               if (c != '\0')
               {
                  resp += c;
               }
            }
         } while ((count == 0) || (c != '\0'));
         cout << "Received response: " << resp << endl;
      }
   }
   close(sock);
   return 0;
}
